jQuery(document).ready(function($){
  // setTimeout(function(){
  //   console.log( 'window.elementorFrontend: ', window.elementorFrontend.hooks );
  // }, 2000);

  // Make our custom css visible in the panel's front-end
	////////////////////////////////////// section clip path editor update settings
		elementor.hooks.addFilter( 'editor/style/styleText', function( css, context ) {
			if ( ! context ) {
				return;
			}

			var model = context.model;

			var customCSS = '';
			var settings = model.get('settings');
			var devices = [ 'desktop', 'tablet_bea', 'mobile_bea' ];
			var clip_path_string = '';

			for (var i = 0; i < devices.length; i++) {
				if(
					settings.get('clip_path_top_on_' + devices[i]) === 'yes' ||
					settings.get('clip_path_bottom_on_' + devices[i]) === 'yes'
				){

					var width_px = 700;
					var height_px = 300;


			    var inverted = false;

			    var brkpt = settings.get('clip_path_brkpt_' + devices[i]);
					var pth = 'selector{clip-path: polygon(100% 100%, 0% 100% ';
					var invpth = 'selector{clip-path: polygon(100% 0%, 0% 0% ';

					if( devices[i] === 'mobile_bea' || devices[i] === 'tablet_bea' ){
						var path = '@media screen and (max-width:' + brkpt + 'px){' + pth;
					  var invertedpath = '@media screen and (max-width:' + brkpt + 'px){' + invpth;
					}
					else{
						var path =  pth;
					  var invertedpath = invpth;
					}

					if(
						settings.get('clip_path_top_on_' + devices[i]) === 'yes' &&
						settings.get('clip_path_bottom_on_' + devices[i]) !== 'yes'
					){
						var clip_path_string =  path;
					}
					if(
						settings.get('clip_path_top_on_' + devices[i]) !== 'yes' &&
						settings.get('clip_path_bottom_on_' + devices[i]) === 'yes'
					){
						var clip_path_string =  invertedpath;
					}
					else{
						var clip_path_string =  path;
					}

					if( settings.get('clip_path_top_on_' + devices[i]) === 'yes' ){
						var offset =  settings.get('clip_path_offset_' + devices[i]);
				    var amplitude =  settings.get('clip_path_amplitude_' + devices[i]);
				    var frequency =  settings.get('clip_path_frequency_' + devices[i]);
				    var phase =  settings.get('clip_path_phase_' + devices[i]);
				    var points =  settings.get('clip_path_points_' + devices[i]);
						var units = 2 * Math.PI * frequency / points;
						var rad_phase =  phase * Math.PI / 180;
						for (var a = 0; a <= points; a++) {
				        var val =  offset + amplitude * Math.cos(a * units + rad_phase);
				        var valY = (val / height_px * 100).toFixed(2);
				        var valX = (a * 100 / points).toFixed(2);
				        clip_path_string += ', ' + valX + '% ' + valY + '%';
				    }
					}

					if( settings.get('clip_path_bottom_on_' + devices[i]) === 'yes' ){
						var offset_bottom =  settings.get('clip_path_offset_bottom_' + devices[i]);
				    var amplitude_bottom =  settings.get('clip_path_amplitude_bottom_' + devices[i]);
				    var frequency_bottom =  settings.get('clip_path_frequency_bottom_' + devices[i]);
				    var phase_bottom =  settings.get('clip_path_phase_bottom_' + devices[i]);
				    var points_bottom =  settings.get('clip_path_points_bottom_' + devices[i]);
						var units_bottom = 2 * Math.PI * frequency_bottom / points_bottom;
						var rad_phase_bottom =  phase_bottom * Math.PI / 180;
						var bottom_points = [];
						for (var b = 0; b <= points_bottom; b++) {
				        var val_bottom =  offset_bottom + amplitude_bottom * Math.cos(b * units_bottom + rad_phase_bottom);
				        var valY_bottom = (val_bottom / height_px * 100).toFixed(2);
				        var valX_bottom = (b * 100 / points_bottom).toFixed(2);
				        bottom_points[b] = ', ' + valX_bottom + '% ' + valY_bottom + '%';
				    }

						if(
							settings.get('clip_path_top_on_' + devices[i]) !== 'yes' &&
							settings.get('clip_path_bottom_on_' + devices[i]) === 'yes'
						){
							var bottom_points_final =  bottom_points;
						}
						else{
							var bottom_points_final = bottom_points.reverse();
							bottom_points_final.push(',0% 100%');

						}

						clip_path_string += bottom_points_final.join('') ;
					}

			    if( devices[i] === 'mobile_bea' || devices[i] === 'tablet_bea' ){
						clip_path_string += ');}}';
					}
					else{
						clip_path_string += ');}';
					}


				} // if
				customCSS +=  clip_path_string;
			} // for


			var selector = '.elementor-element.elementor-element-' + model.get('id');

			if ( 'document' === model.get('elType') ) {
				selector = elementor.config.document.settings.cssWrapperSelector;
			}

			if ( customCSS ) {
				css += customCSS.replace(/selector/g, selector);
			}
			// console.log('css: ', css);
			return css;
		});

});
